=== debian/changelog ===
ntdb (1.0-9) unstable; urgency=low

  * Drop '-b unstable' flag in Vcs-Git.

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 13 Dec 2015 16:08:08 +0000

ntdb (1.0-8) unstable; urgency=medium

  * Avoid duplicating license contents in debian/copyright.

 -- Jelmer Vernooij <jelmer@debian.org>  Fri, 04 Dec 2015 17:04:59 +0000

ntdb (1.0-7) unstable; urgency=medium

  * Add reproducible.diff: Make manual page builds reproducible.
  * Fix use of -Wl,--as-needed in LDFLAGS.

 -- Jelmer Vernooij <jelmer@debian.org>  Sat, 09 May 2015 23:56:14 +0000

ntdb (1.0-6) unstable; urgency=medium

  * debian/copyright: Add short license names, paragraph for main files.
  * Bump standards version to 3.9.6 (no changes).
  * Use -Wl,--as-needed when linking.

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 26 Apr 2015 10:28:58 +0000

ntdb (1.0-5) unstable; urgency=medium

  * Use canonical URL in Vcs-Git header.
  * Set branch in Vcs-Git header.

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 06 Jul 2014 00:08:56 +0200

ntdb (1.0-4) unstable; urgency=medium

  * Bump standards version to 3.9.5 (no changes).
  * Add missing period at end of ntdb-tools long description. Closes:
    #745693
  * Don't build on hurd-any, as the Hurd does not yet support byte range
    locking. (bug #190367)

 -- Jelmer Vernooij <jelmer@debian.org>  Fri, 25 Apr 2014 02:23:08 +0200

ntdb (1.0-3) unstable; urgency=medium

  * Improve spelling of long description. Closes: #737178
  * Drop autopkgtest control flag. Closes: #737542
  * Change maintainer to Debian Samba Maintainers, move myself to
    uploaders.

 -- Jelmer Vernooij <jelmer@debian.org>  Mon, 03 Feb 2014 23:52:08 +0000

ntdb (1.0-2) unstable; urgency=low

  * Remove broken autopkgtest. Closes: #731593

 -- Jelmer Vernooij <jelmer@debian.org>  Sun, 08 Dec 2013 16:08:34 +0000

ntdb (1.0-1) unstable; urgency=low

  * Initial release. Closes: #729165

 -- Jelmer Vernooij <jelmer@debian.org>  Fri, 15 Nov 2013 22:06:52 +0000
