=== debian/watch ===
version=3
http://ftp.samba.org/pub/tdb ntdb-(.+).tar.gz
